;###################
; Notizen



.nolist
#include "ion.inc"
#include "keyval.inc"
;###############     VARIABELN
FieldNumber      =saferam1
DotX1   =FieldNumber+1
DotY1   =DotX1 +1
DotX2   =DotY1+1
DotY2   =DotX2+1
MoveCounter = DotY2+1 ;2bytes
FieldBuffer =MoveCounter+2 ;26 bytes

MaxFields = 42 ; = verfgbare Felder +1
FieldBytes = 13
FieldWidth = 5
;############### ENDE VARIABELN
.list
#ifdef TI83P
    .org    progstart-2
    .db $BB,$6D
#else
    .org progstart
#endif
    xor a
    jr nc,start
titel:  .db "TiltMaze83",0 
start: 
    inc a
    ld (FieldNumber),a
    bcall(_indicatorOff)
    bcall(_cleargbuf)

    ld ix,TScreen
    ld bc,61*256+8
    xor a
    ld l,a
    call IonLargeSprite
    call IonFastCopy
    
    ld hl,TitleScreenText1
    ld de,2*256+96-32
    call DispVText
    ld de,11*256+96-34
    call DispVText
    ld de,18*256+96-25
    call DispVText
    ld de,64-6*256+96-29
    call DispVText

    
    bcall(_GetKey)
Restart:
    ld hl,0
    ld (MoveCounter),hl

    bcall(_cleargbuf)   

    ld a,(FieldNumber)
    ld l,a
    ld h,0
    push hl
    pop de
    ld b,FieldBytes -1
FieldCalcLoop:
    add hl,de
    djnz FieldCalcLoop
    ld de,FieldData - FieldBytes
    add hl,de
    ex de,hl

    ld hl,FieldBuffer
    push hl
    ld b,FieldBytes
Decompress:
    ld a,(de)
    push af
    srl a
    srl a
    srl a
    sra a
    ld (hl),a
    pop af
    inc hl
    and %00001111
    ld (hl),a
    inc hl
    inc de
    djnz Decompress
    


    pop hl ;FieldBuffer
DrawField:
    xor     a
drawLevelNextY:
    ld      (_drawLevelY),a 
    xor     a
drawLevelNextX:
    ld      (_drawLevelX),a 
    ld      a,(hl)                        
    push hl
    ld de,0
    ld hl,0*256+12
    bit 0,a
    call nz,DrawWall ;left
    ld de,0
    ld hl,12*256+0
    bit 1,a
    call nz,DrawWall ;top
    ld de,12*256+0
    ld hl,12*256+12
    bit 2,a
    call nz,DrawWall ;right
    ld de,0*256+12
    ld hl,12*256+12
    bit 3,a
    call nz,DrawWall ;bottom
    pop hl
    inc     hl                             
    ld      a,0
_drawLevelX = $-1
    add     a,12

    cp      5*12                             
    jr      c,drawLevelNextX               
    ld      a,0
_drawLevelY = $-1
    add     a,12
    cp      5*12
    jr      c,drawLevelNextY 

;InitVar
    ld hl,$0000
    ld (DotX1),hl
    ld hl,$0001
    ld (DotX2),hl




    call DrawDots

    ld de,FinishDotX1
    ld hl,DotSPR2
    push hl
    call DrawSPR

    ld de,FinishDotX2
    pop hl
    call DrawSPR


    set textwrite,(iy+sgrflags)
    ld hl,InGameText1
    ld de,2*256+96-32
    call DispVText
    ld de,15*256+96-28
    call DispVText
    ld de,33*256+96-28
    call DispVText

    ld a,(FieldNumber)
    ld de,23*256+96-20
    call vDispA    
    res textwrite,(iy+sgrflags)
    
MainLoop:
    call IonFastCopy
    ld hl,(MoveCounter)
    ld de,41*256+96-20
    call vDispHL
Keys:
    bcall(_Getcsc)
    cp gMode
    ret z
    cp gDel
    jp z,Restart
    ld bc,$00FF
    ld d,2
    cp gUp
    jr z,ShiftDots
    ld bc,$0100
    ld d,4
    cp gRight
    jr z,ShiftDots
    ld bc,$FF00
    ld d,1
    cp gLeft
    jr z,ShiftDots
    ld bc,$0001
    ld d,8
    cp gDown
    jr z,ShiftDots
;    ld c,1
    cp gAdd
    jr z,ChangeLevel
    ld c,-1
    cp gSubtract
    jr nz,Keys

ChangeLevel:
    ld hl,FieldNumber
    ld a,(hl)
    add a,c
    or a
    jr nz,ChangeLevelNotTooLow
    ld a,MaxFields-1
ChangeLevelNotTooLow:
    cp MaxFields
    jr nz,ChangeLevelNotTooHigh
    ld a,1
ChangeLevelNotTooHigh:
    ld (hl),a
    jp Restart

Finished:
    call IonFastCopy
    ld hl,(MoveCounter)
    ld de,41*256+96-20
    call vDispHL

    ld hl,InGameText2
    ld de,50*256+96-32
    call DispVText

    bcall(_GetKey)
    ld c,1
    jr ChangeLevel

ShiftDots:
    ld a,d
    ld (ShiftItMask),a
    push bc
    pop hl
    ld (ShiftItLoopBC),hl
    call DrawDots

    ld hl,DotX1
    call ShiftIt
    ld hl,DotX2
    call ShiftIt

    ld hl,DotX2
    ld de,DotX1
    ld a,(de)
    cp (hl)
    jr nz,ShiftDotsNotOver
    inc hl
    inc de
    ld a,(de)
    cp (hl)
    jr nz,ShiftDotsNotOver
    ;bc sollte noch Add vars enthalten
    sub c
    ld (de),a
    dec de
    ld a,(de)
    sub b
    ld (de),a


ShiftDotsNotOver:
    call DrawDots
    ld hl,(MoveCounter)
    inc hl
    ld (MoveCounter),hl

    ld hl,DotX1
    ld d,$04

    ld a,(hl) ;DotX1
    sub 4 ;cp 4
    ld e,3
    jr z,ShiftDotFinishCheck
    inc e
    inc a ;cp 3
    jr nz,ShiftDotNotFinished
ShiftDotFinishCheck:
    inc hl ;DotY1
    ld a,(hl)
    sub 4 ;cp 4
    jr nz,ShiftDotNotFinished
    inc hl ;DotX2
    ld a,(hl)
    cp e
    jr nz,ShiftDotNotFinished
    inc hl ;DotY2
    ld a,(hl)
    cp 4
    jr z,Finished
ShiftDotNotFinished:
    jp MainLoop






ShiftIt
    push hl
;########
    ld a,(hl)
    ld (ShiftItVarX),a
    inc hl
    ld a,(hl)
    ld (ShiftItVarY),a
    ld bc,0
ShiftItBigLoop:
    ld de,ShiftItVarX
    ld a,(de)
    add a,b
    ld (de),a
    ld de,ShiftItVarY
    ld a,(de)
    add a,c
    ld (de),a

;##########
    ld hl,FieldBuffer
    ld de,0
ShiftItVarX = $-2
    add hl,de ;x add

    ld b,0
ShiftItVarY = $-1
    ld a,b
    or a
    jr z,NoShiftItLoop
    ld e,FieldWidth
ShiftItLoop:
    add hl,de
    djnz ShiftItLoop
NoShiftItLoop:
    
    ld a,(hl)
    ld bc,0
ShiftItLoopBC = $-2

    and 0
ShiftItMask = $-1
    jr z,ShiftItBigLoop

    ld a,(ShiftItVarX)
    pop hl
    ld (hl),a
    inc hl
    ld a,(ShiftItVarY)
    ld (hl),a
    ret


DrawDots:
    ld de,DotX1
    ld hl,DotSPR
    push hl
    call DrawSPR

    ld de,DotX2
    pop hl
    call DrawSPR
    ret



DrawSPR:
    push hl
    pop ix
    ex de,hl
    ld a,(hl)
    ld b,a
    add a,a ;*2
    add a,b ;*3
    add a,a ;*6
    add a,a ;*12
    inc a
    push af
    inc hl
    ld a,(hl)
    ld b,a
    add a,a ;*2
    add a,b ;*3
    add a,a ;*6
    add a,a ;*12
    add a,2
    ld l,a
    pop af
    ld bc,9*256+2
    call IonLargeSprite
    ret



DrawWall: 
    push af
    ld a,(_drawLevelX)
    push af
    add a,d
    ld d,a
    pop af
    add a,h
    ld h,a
    ld a,(_drawLevelY)
    push af
    add a,e
    ld e,a
    pop af
    add a,l
    ld l,a
    call LineDraw
    pop af
    ret


DispVText:
    ld (PENCOL),de
    bcall(_vputs)
    ret

vDispA:
    ld h,0
    ld l,a
vDispHL:
    ld (PENCOL),de
    push hl
    ld de,op1+5
    xor a
    ld (de),a
vDispHLloop:
    bcall(_divhlby10)
    add a,'0'
    dec de
    ld (de),a
    ld a,h
    or l
    jr nz,vDispHLloop
    ex de,hl
    bcall(_vputs)
    pop hl
    ret


;########################
;## Routine by Badja ####
;########################
lineDraw:
      ld    a,h
      sub   d
      jr    nc,ld_noAbsX
      neg
ld_noAbsX:
      ld    b,a               ; B = |dx|
      ld    a,l
      sub   e
      ld    c,a               ; C = dy
      jr    nc,ld_noAbsY
      neg
ld_noAbsY:                    ; A = |dy|
      cp    b
      jr    nc,ld_rotated

      ld    a,h
      sub   d                 ; A = dx
      bit   7,a
      jr    z,ld_noSwap1
      ex    de,hl
      ld    a,b               ; A = |dx|
ld_noSwap1:
      push  af
      push  de
      neg
      ld    d,a               ; D = -dx
      ld    bc,12
      ld    a,e
      cp    l
      jr    c,ld_noReflectX
      ld    e,l
      ld    l,a
      ld    bc,-12
ld_noReflectX:
      ld    (ld_setIncrY),bc
      ld    b,$ff
      ld    c,d               ; BC = -dx
      ld    h,0               ; HL = y1
      ld    d,h               ; DE = y0
      and   a                 ; set C flag to zero
      sbc   hl,de             ; HL = dy
      add   hl,hl
      ld    (ld_setIncrE),hl
      add   hl,bc
      ld    d,h
      ld    e,l               ; DE = d
      add   hl,bc
      ld    (ld_setIncrESE),hl
      pop   bc                ; B = x0, C = y0
      push  de
      ld    a,b
      ld    e,c
      call  ionGetPixel       ; HL -> graphbuffer offset, A = pixel mask
      push  hl
      pop   ix                ; IX -> graphbuffer offset
      pop   hl                ; HL = d
      pop   bc                ; B = |dx|
      ld    d,a
      or    (ix)
      ld    (ix),a
      ld    a,b
      or    a
      ret   z
ld_lineLoopE:
      ld    a,d
      bit   7,h
      jr    z,ld_goESE
ld_setIncrE = $ + 1
      ld    de,$0000
      add   hl,de
      jr    ld_incrementX
ld_goESE:
ld_setIncrESE = $ + 1
      ld    de,$0000
      add   hl,de
ld_setIncrY = $ + 1
      ld    de,$0000
      add   ix,de
ld_incrementX:
      rrca
      jr    nc,ld_sameByte1
      inc   ix
ld_sameByte1:
      ld    d,a
      or    (ix)
      ld    (ix),a
      djnz  ld_lineLoopE
      ret

ld_rotated:
      bit   7,c               ; C = dy
      jr    z,ld_noSwap2
      ex    de,hl
      ld    c,a               ; C = |dy|
ld_noSwap2:
      ld    a,c
      push  af
      push  de
      neg
      ld    c,a               ; C = -dy
      ld    l,h
      ld    e,d
      ld    a,e
      cp    l
      ld    a,$0f             ; opcode for RRCA
      ld    b,$23             ; second byte of opcode for INC IX
      jr    c,ld_noReflectY
      ld    e,l
      ld    l,d
      ld    a,$07             ; opcode for RLCA
      ld    b,$2b             ; second byte of opcode for DEC IX
ld_noReflectY:
      ld    (ld_setIncrX1),a
      ld    a,b
      ld    (ld_setIncrX2),a
      ld    b,$ff             ; BC = -dy
      ld    h,0               ; HL = x1
      ld    d,h               ; DE = x0
      and   a                 ; set C flag to zero
      sbc   hl,de             ; HL = dx
      add   hl,hl
      ld    (ld_setIncrS),hl
      add   hl,bc
      ld    d,h
      ld    e,l               ; DE = d
      add   hl,bc
      ld    (ld_setIncrSSE),hl
      pop   bc                ; B = x0, C = y0
      push  de
      ld    a,b
      ld    e,c
      call  ionGetPixel       ; HL -> graphbuffer offset, A = pixel mask
      push  hl
      pop   ix                ; IX -> graphbuffer offset
      pop   hl                ; HL = d
      pop   bc                ; B = |dy|
      ld    d,a
      or    (ix)
      ld    (ix),a
      ld    a,b
      or    a
      ret   z
ld_lineLoopS:
      ld    a,d
      bit   7,h
      jr    z,ld_goSSE
ld_setIncrS = $ + 1
      ld    de,$0000
      add   hl,de
      jr    ld_incrementY
ld_goSSE:
ld_setIncrSSE = $ + 1
      ld    de,$0000
      add   hl,de
ld_setIncrX1 = $
      rrca
      jr    nc,ld_sameByte2
ld_setIncrX2 = $ + 1
      inc   ix
ld_sameByte2:
ld_incrementY:
      ld    de,12
      add   ix,de
      ld    d,a
      or    (ix)
      ld    (ix),a
      djnz  ld_lineLoopS
      ret


DotSPR:
    .db %00011111, %00000000
    .db %00111111, %10000000
    .db %01111001, %11000000
    .db %01111110, %11000000
    .db %01111110, %11000000
    .db %01111111, %11000000
    .db %01111111, %11000000
    .db %00111111, %10000000
    .db %00011111, %00000000

DotSPR2:
    .db %00011111, %00000000
    .db %00100000, %10000000
    .db %01000000, %01000000
    .db %01000000, %01000000
    .db %01000000, %01000000
    .db %01000000, %01000000
    .db %01000000, %01000000
    .db %00100000, %10000000
    .db %00011111, %00000000

FinishDotX1:
    .db 4,4
FinishDotX2:
    .db 3,4


InGameText1:
    .db "TiltMaze",0
    .db "Level:",0
    .db "Moves:",0
InGameText2:
    .db "You did it!",0

TitleScreenText1:
    .db "by",0
    .db "Peter",0
    .db "Bucher",0
    .db "any key",0


FieldData:   ;41 Fields
    .db     182 ,           115 ,           107 ,           132 ,           28  ,           58  ,           8   ,           105 ,           40  ,           36  ,           253 ,           184 ,           192
    .db     54  ,           54  ,           113 ,           0   ,           4   ,           213 ,           16  ,           195 ,           0   ,           199 ,           156 ,           154 ,           192
    .db     62  ,           50  ,           229 ,           56  ,           6   ,           152 ,           101 ,           83  ,           40  ,           197 ,           217 ,           170 ,           192
    .db     58  ,           99  ,           101 ,           180 ,           93  ,           154 ,           0   ,           227 ,           105 ,           6   ,           217 ,           168 ,           192
    .db     123 ,           99  ,           233 ,           168 ,           71  ,           182 ,           60  ,           211 ,           128 ,           111 ,           154 ,           201 ,           224
    .db     58  ,           111 ,           253 ,           48  ,           111 ,           60  ,           144 ,           101 ,           62  ,           28  ,           221 ,           249 ,           224
    .db     182 ,           54  ,           119 ,           28  ,           28  ,           16  ,           225 ,           97  ,           207 ,           20  ,           154 ,           172 ,           208
    .db     182 ,           58  ,           227 ,           128 ,           103 ,           146 ,           201 ,           79  ,           83  ,           101 ,           184 ,           205 ,           208
    .db     62  ,           50  ,           229 ,           60  ,           150 ,           148 ,           58  ,           199 ,           152 ,           38  ,           154 ,           237 ,           208
    .db     50  ,           107 ,           101 ,           81  ,           36  ,           85  ,           209 ,           197 ,           83  ,           6   ,           152 ,           201 ,           192
    .db     58  ,           99  ,           101 ,           52  ,           28  ,           148 ,           144 ,           227 ,           195 ,           142 ,           154 ,           138 ,           224
    .db     186 ,           38  ,           123 ,           105 ,           4   ,           176 ,           32  ,           207 ,           81  ,           134 ,           184 ,           142 ,           208
    .db     54  ,           182 ,           245 ,           18  ,           6   ,           28  ,           209 ,           73  ,           99  ,           4   ,           184 ,           205 ,           208
    .db     182 ,           58  ,           107 ,           128 ,           101 ,           182 ,           85  ,           83  ,           128 ,           205 ,           154 ,           138 ,           224
    .db     50  ,           166 ,           125 ,           215 ,           85  ,           127 ,           144 ,           73  ,           34  ,           132 ,           184 ,           142 ,           208
    .db     115 ,           227 ,           101 ,           18  ,           4   ,           16  ,           193 ,           73  ,           130 ,           197 ,           186 ,           203 ,           192
    .db     54  ,           182 ,           245 ,           150 ,           22  ,           158 ,           28  ,           91  ,           40  ,           36  ,           253 ,           188 ,           208
    .db     182 ,           58  ,           99  ,           0   ,           101 ,           213 ,           81  ,           203 ,           69  ,           30  ,           249 ,           201 ,           224
    .db     186 ,           42  ,           99  ,           168 ,           101 ,           26  ,           32  ,           65  ,           225 ,           12  ,           158 ,           217 ,           224
    .db     115 ,           38  ,           117 ,           213 ,           20  ,           22  ,           16  ,           73  ,           12  ,           85  ,           249 ,           172 ,           208
    .db     62  ,           50  ,           105 ,           101 ,           148 ,           117 ,           87  ,           85  ,           144 ,           132 ,           219 ,           138 ,           192
    .db     50  ,           111 ,           125 ,           144 ,           36  ,           243 ,           197 ,           83  ,           75  ,           140 ,           217 ,           170 ,           224
    .db     178 ,           166 ,           251 ,           10  ,           6   ,           176 ,           101 ,           91  ,           69  ,           148 ,           253 ,           154 ,           192
    .db     178 ,           166 ,           123 ,           67  ,           4   ,           125 ,           209 ,           65  ,           227 ,           197 ,           223 ,           154 ,           192
    .db     54  ,           123 ,           229 ,           209 ,           103 ,           30  ,           144 ,           73  ,           42  ,           4   ,           249 ,           233 ,           192
    .db     186 ,           166 ,           123 ,           99  ,           12  ,           52  ,           16  ,           109 ,           144 ,           132 ,           251 ,           138 ,           192
    .db     115 ,           170 ,           105 ,           2   ,           164 ,           48  ,           75  ,           73  ,           65  ,           164 ,           188 ,           154 ,           192
    .db     186 ,           107 ,           103 ,           113 ,           36  ,           28  ,           28  ,           81  ,           44  ,           245 ,           152 ,           170 ,           192
    .db     54  ,           58  ,           97  ,           0   ,           237 ,           152 ,           2   ,           99  ,           40  ,           197 ,           221 ,           186 ,           192
    .db     58  ,           166 ,           249 ,           107 ,           199 ,           48  ,           38  ,           85  ,           144 ,           4   ,           158 ,           152 ,           192
    .db     182 ,           178 ,           111 ,           146 ,           197 ,           178 ,           134 ,           87  ,           215 ,           148 ,           158 ,           154 ,           192
    .db     54  ,           178 ,           97  ,           207 ,           85  ,           22  ,           176 ,           73  ,           67  ,           4   ,           249 ,           205 ,           208
    .db     182 ,           115 ,           227 ,           132 ,           87  ,           22  ,           24  ,           65  ,           201 ,           36  ,           154 ,           168 ,           192
    .db     178 ,           162 ,           99  ,           6   ,           28  ,           81  ,           12  ,           117 ,           144 ,           164 ,           223 ,           154 ,           192
    .db     186 ,           42  ,           103 ,           121 ,           101 ,           16  ,           32  ,           193 ,           205 ,           22  ,           154 ,           172 ,           208
    .db     178 ,           107 ,           235 ,           73  ,           111 ,           60  ,           48  ,           229 ,           245 ,           150 ,           158 ,           154 ,           192
    .db     58  ,           107 ,           105 ,           105 ,           44  ,           60  ,           113 ,           229 ,           56  ,           6   ,           152 ,           172 ,           208
    .db     50  ,           38  ,           249 ,           69  ,           87  ,           245 ,           144 ,           195 ,           142 ,           95  ,           154 ,           168 ,           224
    .db     178 ,           170 ,           103 ,           18  ,           229 ,           144 ,           67  ,           195 ,           193 ,           199 ,           158 ,           154 ,           192
    .db     54  ,           58  ,           105 ,           128 ,           172 ,           54  ,           150 ,           121 ,           71  ,           20  ,           249 ,           140 ,           208
    .db     178 ,           38  ,           247 ,           209 ,           14  ,           211 ,           136 ,           99  ,           2   ,           109 ,           156 ,           217 ,           224

TScreen:
    .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000
    .db %10000000,%00000000,%00000000,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %10001111,%10000000,%00000000,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %10011111,%11000000,%00000000,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %10111100,%11100000,%00000000,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %10111110,%01100000,%00000000,%10000000,%00000100,%00000000,%10000000,%00001000
    .db %10111111,%01100000,%00000000,%10000000,%00001010,%00000000,%10000000,%00001000
    .db %10111111,%11100000,%00000000,%10000000,%00011010,%00000000,%10000000,%00001000
    .db %10111111,%11100000,%00000000,%10000000,%00011010,%00000000,%10000000,%00001000
    .db %10011111,%11000000,%00000000,%10111000,%00011101,%00000000,%10000000,%00001000
    .db %10001111,%10000000,%00000000,%11100100,%00011101,%10000000,%10000000,%00001000
    .db %10000000,%00000000,%00000000,%11110100,%00011110,%11100000,%10000000,%00001000
    .db %10000000,%00001000,%00100000,%11110011,%11111110,%00100000,%11111111,%11111000
    .db %10000000,%00001000,%11010000,%11111010,%00001100,%01100000,%00000000,%00001000
    .db %10000000,%00001000,%11110000,%01111101,%00011111,%01000000,%00000000,%00001000
    .db %10000000,%00111001,%11100000,%00011101,%00011111,%01000000,%00000000,%00001000
    .db %10000001,%11001001,%11100000,%00011101,%10011111,%10101100,%00000000,%00001000
    .db %10001110,%00111000,%11000000,%00011110,%10011011,%10110100,%00000000,%00001000
    .db %10011000,%01001000,%00000100,%00001110,%10001011,%10000100,%00000000,%00001000
    .db %10011111,%01101000,%00111100,%00001110,%01001011,%11011000,%00000000,%00001000
    .db %10111111,%10101000,%00100010,%00001111,%01111001,%11111000,%00000000,%00001000
    .db %10111111,%10011000,%01111010,%00000111,%01001001,%11110000,%00000000,%00001000
    .db %10000011,%11011000,%01111011,%00000111,%00111000,%01100000,%00000000,%00001000
    .db %10000001,%11011000,%01111001,%00000110,%11111000,%00000000,%00000000,%00001000
    .db %10000001,%11101111,%11111101,%11100111,%11111000,%00000000,%11111111,%11111000
    .db %10000000,%11101000,%00001101,%00100111,%11000000,%00000000,%00000011,%11101000
    .db %10000000,%11100100,%00001100,%11100111,%00000000,%00000000,%00001100,%00011000
    .db %10000000,%11110100,%00001111,%11000000,%00000000,%00000000,%00010001,%11001000
    .db %10000000,%01110100,%00001111,%11000000,%00000000,%00000000,%00100111,%11101000
    .db %10000000,%01111010,%00001110,%10000000,%00000000,%00000100,%00101111,%00011000
    .db %10000000,%01111110,%00000000,%10000000,%00000000,%00011010,%01101100,%11111100
    .db %10000000,%00111110,%00000000,%10000000,%00000000,%11100010,%01101011,%11110100
    .db %10000000,%00011100,%00000000,%10000000,%00000111,%00011010,%01100111,%11100100
    .db %10000000,%00000001,%11000000,%10000000,%00000110,%11111010,%01110011,%00011000
    .db %10000000,%00000010,%01000000,%10000000,%11000111,%11110100,%01111000,%11111000
    .db %10000000,%00000010,%00100000,%10000111,%01001111,%11101011,%10111111,%11111000
    .db %11111111,%11111100,%10111111,%10111000,%01001111,%01011110,%10111111,%11101000
    .db %10000110,%11000101,%10100000,%01000111,%01100000,%10011000,%10001111,%00001000
    .db %10001100,%00100101,%11010000,%01011111,%10100000,%10100111,%10000000,%00001000
    .db %10001100,%10010101,%11010000,%10011111,%10100001,%10011111,%00000000,%00001000
    .db %10001110,%11001101,%11101001,%10011000,%10111001,%11111111,%00000000,%00001000
    .db %10001110,%11100101,%11101001,%11010001,%10001001,%11111000,%00000000,%00001000
    .db %10001111,%01111001,%11101101,%11001110,%00111001,%11100000,%00000000,%00001000
    .db %10000111,%01111101,%11110101,%11100000,%11111000,%00000000,%00000000,%00001000
    .db %10000111,%10111111,%01110100,%11111111,%11110000,%00000000,%00000000,%00001000
    .db %10000011,%10111110,%01110010,%11111111,%11000000,%00000000,%00000000,%00001000
    .db %10000011,%10011110,%01111010,%11111111,%00000000,%00000000,%00000000,%00001000
    .db %10000011,%11010110,%00111110,%00111000,%00000000,%00000000,%00000000,%00001000
    .db %11111111,%11011010,%00111110,%11111111,%11111000,%00000000,%10000000,%00001000
    .db %10000001,%11101000,%00011100,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %10000000,%11101000,%00011000,%10001111,%10000000,%11111000,%10001111,%10001000
    .db %10000000,%11111000,%00000000,%10011111,%11000001,%00000100,%10010000,%01001000
    .db %10000000,%11111000,%00000000,%10111100,%11100010,%00000010,%10100000,%00101000
    .db %10000000,%01111000,%00000000,%10111110,%01100010,%00000010,%10100000,%00101000
    .db %10000000,%01101000,%00000000,%10111111,%01100010,%00000010,%10100000,%00101000
    .db %10000000,%00001000,%00000000,%10111111,%11100010,%00000010,%10100000,%00101000
    .db %10000000,%00001000,%00000000,%10111111,%11100010,%00000010,%10100000,%00101000
    .db %10000000,%00001000,%00000000,%10011111,%11000001,%00000100,%10010000,%01001000
    .db %10000000,%00001000,%00000000,%10001111,%10000000,%11111000,%10001111,%10001000
    .db %10000000,%00001000,%00000000,%10000000,%00000000,%00000000,%10000000,%00001000
    .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000

.end
END
